package com.offcn.api.xyzb;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MyDateUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.XYZB;

import net.sf.json.JSONObject;



/**
 * 新增通讯录
 * 
 * @author puhui
 *
 */
public class room_mails_add extends XYZB implements API {
	public String parameter;//参数集合
	
	public String name;//房间名称
	public String phone;//房间名称
	public String room_num;//房间名称
	public String identity;
	public String id;

	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		name = MapUtil.getParameter(parameter, "name").trim();
		phone = MapUtil.getParameter(parameter, "phone").trim();
		room_num = MapUtil.getParameter(parameter, "room_num").trim();
		identity = MapUtil.getParameter(parameter, "identity").trim();
		
		if ((!room_num.equals("")) && room_num.equals("code")) {
			room_num=Current_room;
			parameter = parameter.replace("\"room_num\":code", "\"room_num\":\""+ room_num + "\"");
		}
		
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Response re = RequestDataUtils.Post_token(data, Url,Client_token);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(jp.getString("msg"));
			
			if ((data.get("code") != null )
					&& ((jp.getString("code") == null) || (!jp.getString(
							"code").equals(data.get("code").toString())))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null)
					&& ((msg == null) || (!msg.equals(data.get("msg").toString())))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			if("操作成功".equals(jp.getString("msg"))){
				
				//是否是线上环境
				if (!isProduct && !(room_num.equals("'"))) {
					try {
						ResultSet rs_bankcard = this.selectFromDB(
								" xyu_room_mails  f ",
								" f.room_num = '" + room_num + "' ");
						rs_bankcard.last();
//						System.out.println(rs_bankcard.getRow());
						if (rs_bankcard.getRow() < 1) {
							result = result && false;
							failReason = failReason + "xyu_room_mails info is not in DB;";
						} else {
							
							String act_identity = String
									.valueOf(rs_bankcard.getString(rs_bankcard.findColumn("identity")));
							String act_name = String
									.valueOf(rs_bankcard.getString(rs_bankcard.findColumn("name")));
							String act_phone = String
									.valueOf(rs_bankcard.getString(rs_bankcard.findColumn("phone")));
							id = String
									.valueOf(rs_bankcard.getString(rs_bankcard.findColumn("id")));
							
							name = MapUtil.killQuotes(name, "\"");//去掉双引号的name
							
							if ((!name.equals(act_name)) 
									|| (!identity.equals(act_identity))
									|| (!phone.equals(act_phone))
									){
								result = result && false;
								failReason = failReason + "xyu_room_files info in DB is wrong;";
							} else {
								Current_mails_id=id;
								Log.logInfo("xyu_room_files info in DB is correct;");
							}
						}
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify xyu_room_files info in DB;";
						e.printStackTrace();
					}
				}
			}
			
			
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
